/* Copyrights 2002 Luis Figueiredo (stdio@netc.pt) All rights reserved. 
 *
 * See the LICENSE file
 *
 * The origin of this software must not be misrepresented, either by
 * explicit claim or by omission.  Since few users ever read sources,
 * credits must appear in the documentation.
 *
 * date: Sat Mar 30 14:44:42 GMT 2002
 *
 *
 * --
 *
 */

#ifndef _CLIENT_H_
#define _CLIENT_H_

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <fcntl.h>
#include <string.h>

#include <errno.h> // only in windows?

#ifdef HAVE_OPENSSL

#include <openssl/rsa.h>       /* SSLeay stuff */
#include <openssl/crypto.h>
#include <openssl/x509.h>
#include <openssl/pem.h>
#include <openssl/ssl.h>
#include <openssl/err.h>              

#endif

#include "socket.h"

#include "memory.h"
#include "outstream.h"


#include "gethandler.h"
#include "weblog.h"
#include "utils.h"
#include "fnmatch.h"
#include "outgif.h"
#include "debug.h"



//#include "server.h" 

#include "clientinfo.h" // NEW


#ifdef WIN32
#define vsnprintf _vsnprintf
#endif

#define READMAX 200000 // CHANGE TO 200000
#define WRITEMAX 200000 //CHANGE TO 200000 //200k upload
#define MAXURLSIZE 8000



struct web_client {
        int socket;
        struct outstream *outstream;
        struct sockaddr_in sa;

        unsigned int salen;
	
        char *rbuf;
        int rbufsize;
	int newdata_try;
#ifdef HAVE_OPENSSL
	SSL *ssl;
	X509*    cert;
#endif
	int wrotesize;
	char *HTTPdirective;
			 
        unsigned char stat;  /* 0001b idle,0010b down streaming, 0011 done down streaming, 0100b out streaming,0101 done out streaming */
	struct web_client *next;
};                      
extern struct web_client *current_web_client;

struct web_client *init_client_list();
int add_client(struct web_client *,struct web_client *);
void delete_next_client(struct web_client *);

void read_client(struct web_client *);
void process_client(struct web_client *,struct gethandler *);
void output_client(struct web_client *);

void web_client_writef(struct web_client *,const char *,...);

int web_client_addfile(char *);
int web_client_outputgif(char *,int,int);

void web_client_HTTPdirective(char *);

char *web_client_getreqline();
char *web_client_getreq();

#endif

