/* Copyrights 2002 Luis Figueiredo (stdio@netc.pt) All rights reserved. 
 *
 * See the LICENSE file
 *
 * The origin of this software must not be misrepresented, either by
 * explicit claim or by omission.  Since few users ever read sources,
 * credits must appear in the documentation.
 *
 * date: Wed Oct  9 19:05:48 GMT 2002
 *
 *
 * --
 *
 */

#ifndef _CLIENTINFO_H_
#define _CLIENTINFO_H_

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <fcntl.h>
#include <string.h>

#include "outstream.h"
#include "client.h"
#include "utils.h"
#include "memory.h"


/*
 * Next's structs are redudant but it is an case of logic (spell)
 */
struct _Header {
	char *id;
	char *data;
	struct _Header *next;
};
struct _Query {
	int index;
	int idf;
	char *id;
	char *data;
	struct _Query *next;
};
struct _Post {
	int index;
	int idf;
	char *id;
	char *data;
	struct _Post *next;
};

struct _MultiPart {
	char *id;
	char *data;
	unsigned int size;
	char *filename;
	struct _MultiPart *next;
};

struct _Cookie {
	char *id;
	char *data;
	struct _Cookie *next;
};


extern struct ClientInfo {
	int outfd;
	char *inetname;
	char *request;
	char *method;
	char *user;
	char *pass;
	
	char *(*Header)(char *);
	char *(*Query)(char *);
	char *(*Post)(char *);
	char *(*Cookie)(char *); // TODO
	struct _MultiPart (*MultiPart)(char *); 
	// not necessary for web_server.h
	char *QueryString;
	char *CookieString;
	char *PostData;
	struct memrequest *mem;
	struct _Header *HeaderList; // Not necessary for web_server.h
	struct _Query *QueryList; // Not necessary for web_server.h
	struct _Post *PostList; // Not necessary for web_server.h
	struct _MultiPart *MultiPartList; // Not necessary for web_server.h
	struct _Cookie *CookieList; // Not necessary for web_server.h
} *ClientInfo;      


void init_clientinfo();
void free_clientinfo();
char *clientinfo_getauthuser();
char *clientinfo_getauthpass();
char *clientinfo_getquerystring();
char *clientinfo_getpostdata();
char *clientinfo_getcookiestring();
char *clientinfo_getmethod();
char *clientinfo_getreqname();
char *__Header(char *);
char *__Query(char *);
char *__Post(char *);
struct _MultiPart __MultiPart(char *);
char *__Cookie(char *);

#endif

