/* Copyrights 2002 Luis Figueiredo (stdio@netc.pt) All rights reserved. 
 *
 * See the LICENSE file
 *
 * The origin of this software must not be misrepresented, either by
 * explicit claim or by omission.  Since few users ever read sources,
 * credits must appear in the documentation.
 *
 * date: Sat Mar 30 14:25:25 GMT 2002 
 *
 *  memory functions
 */

#ifndef _MEMORY_H_
#define _MEMORY_H_

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif         


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h> // Johannes E. Schindelin

#include "debug.h"

extern int errno;

void *mymalloc(size_t);
void *mycalloc(size_t,size_t);
void *myrealloc(void *,size_t);
void myfree(void *);

struct memrequest {
	char *ptr;
	struct memrequest *next;
};
struct memrequest *init_buffer_list();
void *add_buffer(struct memrequest *,unsigned int);
void delete_buffer(struct memrequest *);
void delete_next_buffer(struct memrequest *);
void delete_buffer_list(struct memrequest *);

#endif
