/* Copyrights 2002 Luis Figueiredo (stdio@netc.pt) All rights reserved. 
 *
 * See the LICENSE file
 *
 * The origin of this software must not be misrepresented, either by
 * explicit claim or by omission.  Since few users ever read sources,
 * credits must appear in the documentation.
 *
 * date: Sat Mar 30 14:44:42 GMT 2002
 *
 *
 * --
 *
 */

#ifndef _SERVER_H_
#define _SERVER_H_

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif         

#include <stdio.h>
#include <signal.h>


#include "memory.h"
#include "client.h"
#include "gethandler.h"
#include "socket.h"

#include "debug.h"


extern char *_web_server_version;
extern struct web_server *current_web_server; 
struct web_server {
        int socket;
        FILE *weblog;
	int flags;
        struct gethandler *gethandler;
        struct web_client *client;
	int usessl;
#ifdef HAVE_OPENSSL
	char *cert_file;
	SSL_CTX* ctx;
#endif 
	struct {
		unsigned long connection;
		unsigned long bsent;
		unsigned long brecv;
	}stat;

};                                                                                                                             
#define WS_ONLYLOCAL 1 // Can be only accessed by localhost
#define WS_USESSL 2 // Use ssl conections (openssl lib required)      
 
void web_server_useSSLcert(struct web_server *,const char *); // Mandatory if WS_USESSL set
int web_server_init(struct web_server *,int,const char *,int);
int web_server_addhandler(struct web_server *,const char *,void (*)(),int);
int web_server_run(struct web_server *);
unsigned long web_server_statconnections();
unsigned long web_server_statsent();
unsigned long web_server_statrecv();


#include "weblog.h"

#endif

