/* Copyrights 2002 Luis Figueiredo (stdio@netc.pt) All rights reserved. 
 *
 * See the LICENSE file
 *
 * The origin of this software must not be misrepresented, either by
 * explicit claim or by omission.  Since few users ever read sources,
 * credits must appear in the documentation.
 *
 * date: Sat Mar 30 14:25:25 GMT 2002 
 *
 * -- stream list functions
 */


#include "outstream.h"

/*********************************************************************************************************/ 
/*
 *	add_outstream, add a file to output (client) stream
 */
int add_outstream(struct outstream *list,char *fname,int istmp){
	struct outstream *temp=list;
	while(temp->next!=NULL)temp=temp->next;
	IFDEBUG(fprintf(stderr,"outstream.c: (allocating outstream): ");fflush(stderr);); // REMOVE
	temp->next=mymalloc(sizeof(struct outstream));
	if(temp->next==NULL) {
		fprintf(stderr,"outstream.c: Not enough mem to allocate outstream\n");
		return 0;
	};
	temp->next->fname=NULL;
	if(fname!=NULL) {
		temp->next->fname=mymalloc(strlen(fname)+1);
		if(temp->next->fname==NULL) {
			fprintf(stderr,"outstream.c: Not enough mem to allocate outstream filename\n");
		};
		memcpy(temp->next->fname,fname,strlen(fname));
		temp->next->fname[strlen(fname)]='\0'; 
	};
	temp->next->todelete=istmp;
	temp->next->fstream=NULL;
	temp->next->wsize=1;
	temp->next->rsize=0;
	temp->next->next=NULL;	
	return 1;	
}

/*********************************************************************************************************/
/*
 * Initializate (allocate) outstream list
 */
struct outstream *init_outstream_list() {
	struct outstream *ret;
	IFDEBUG(fprintf(stderr,"outstream.c: Adding Head to outstream\n"));
	IFDEBUG(fprintf(stderr,"outstream.c: (allocating outstream list): ");fflush(stderr);); // REMOVE
	ret=mymalloc(sizeof(struct outstream));
	if(ret==NULL) {
		fprintf(stderr,"outstream.c: Not enough mem to allocate outstream list\n");
		return NULL;
	};
	ret->todelete=0;
	ret->fname=NULL;
	ret->next=NULL;
	return ret;
}

/*********************************************************************************************************/
/*
 * Delete a especific node
 */
void delete_outstream(struct outstream *node) { // Changed
	int rt;
	if(node->todelete) { // is temporary file
		rt=unlink(node->fname);
		if(rt==-1) {
			fprintf(stderr,"outstream.c: Cannot delete temporary file %s\n",node->fname);
		};
		IFDEBUG(fprintf(stderr,"unlink is %d\n",rt));
	};
	myfree(node->fname);
	IFDEBUG(fprintf(stderr,"outstream.c: (freeing outstream): ");fflush(stderr);); // REMOVE
	myfree(node);
}

/*********************************************************************************************************/
/*
 * delete next node 
 */
void delete_next_outstream(struct outstream *node) {
	struct outstream *temp=node->next;
	node->next=node->next->next;
	delete_outstream(temp);
}

/*********************************************************************************************************/
/*
 * delete all nodes on the list (reset list)
 */
void delete_outstream_list(struct outstream *list) {
	struct outstream *temp=list;
	while(temp->next!=NULL) {
		delete_next_outstream(temp);
	};
	delete_outstream(temp);
	
}

