/* Copyrights 2002 Luis Figueiredo (stdio@netc.pt) All rights reserved. 
 *
 * See the LICENSE file
 *
 * The origin of this software must not be misrepresented, either by
 * explicit claim or by omission.  Since few users ever read sources,
 * credits must appear in the documentation.
 *
 * date: 19:49,07-49-2002
 *
 * -- description: utilitys
 *
 */

#include "utils.h"



#ifdef WIN32
#define strncasecmp strnicmp
#endif

/*********************************************************************************************************/
/* 
 * gives a new temporary path(file) name that doesn't exists
 */
char *tmpfname() {
	char *ret=NULL;
	char *tmpdir;
	struct stat foostat;
	tmpdir=getenv("TEMP");
	if(tmpdir==NULL) {
		tmpdir=getenv("TMP");
	};
	if(tmpdir==NULL) {
		tmpdir=getenv("TMPDIR");
	};
	if(tmpdir==NULL) {
		tmpdir=P_tmpdir;  // defined in stdio.h
	};
	ret=mymalloc(strlen(tmpdir)+10);
	do {
		snprintf(ret,strlen(tmpdir)+9,"%s/lws%c%c%c%c",tmpdir,(rand()%26)+65,(rand()%26)+65,(rand()%26)+65,(rand()%26)+65);
		IFDEBUG(fprintf(stderr,"Temporary filename is: %s, stat:%d\n",ret,stat(ret,&foostat)));
	}while((stat(ret,&foostat)!=-1));
	return ret;
};


/*********************************************************************************************************/
/*
 * Search a string on a string ignoring the case
 */
char *strcasestr(char *str, const char *nedle) {
	char *tmp1=str;
	int ret;
	if(strlen(str)<strlen(nedle))return NULL;
	while((ret=strncasecmp(tmp1,nedle,strlen(nedle)) && (unsigned int)(tmp1+strlen(nedle))<=strlen(str))) {
		tmp1++;
	};
	if(ret)
		return NULL;
	return tmp1;
};

/*********************************************************************************************************/
/*
 * an date function
 */
#define DATE_MAX 100
char datem[DATE_MAX];

char *mydate(time_t t,const char *format) {
	struct tm *tm;
	tm=localtime(&t);
	strftime(datem,DATE_MAX,format,tm);
	return datem;
}                    

/*********************************************************************************************************/
/* 
 * wasn't me, base64decode
 */
static const unsigned char chtb[256] = {
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 62, 64, 64, 64, 63,
    52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 64, 64, 64, 64, 64, 64,
    64,  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14,
    15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 64, 64, 64, 64, 64,
    64, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40,
    41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64};          


int base64decode(char *bufplain, const char *bufcoded){
    int nb;
    const unsigned char *in;
    unsigned char *out;
    int nprbytes;
 
    in = (const unsigned char *) bufcoded;
    while (chtb[*(in++)] <= 63);
    nprbytes = (in - (const unsigned char *) bufcoded) - 1;
    nb = ((nprbytes + 3) / 4) * 3;
 
    out = (unsigned char *) bufplain;
    in = (const unsigned char *) bufcoded;
 
    while (nprbytes > 4) {
        *(out++) =
            (unsigned char) (chtb[*in] << 2 | chtb[in[1]] >> 4);
        *(out++) =
            (unsigned char) (chtb[in[1]] << 4 | chtb[in[2]] >> 2);
        *(out++) =
            (unsigned char) (chtb[in[2]] << 6 | chtb[in[3]]);
        in += 4;
        nprbytes -= 4;
    }
    if (nprbytes > 1) {
        *(out++) =
            (unsigned char) (chtb[*in] << 2 | chtb[in[1]] >> 4);
    }
    if (nprbytes > 2) {
        *(out++) =
            (unsigned char) (chtb[in[1]] << 4 | chtb[in[2]] >> 2);
    }
    if (nprbytes > 3) {
        *(out++) =
            (unsigned char) (chtb[in[2]] << 6 | chtb[in[3]]);
    }
 
    nb -= (4 - nprbytes) & 3;
    return nb;
}                                        

